<template>
  <div class="item">
    <div class="thumbnail" :style="{ backgroundImage: `url(${thumbnail})` }"></div>
    <div class="info">
      <h2 class="title">{{ product.title }}</h2>
      <div class="price-container off" v-if="product.off">
        <p class="price price--off">{{ product.price | formatPrice }}</p>
        <p class="unit">تومان</p>
      </div>
      <div class="price-container">
        <p class="price">{{ price | formatPrice }}</p>
        <p class="unit">تومان</p>
      </div>
    </div>
    <div class="actions">
      <Counter :value="product.count" class="counter" @increaseRequest="onIncrease" @decreaseRequest="onDecrease" />
      <Button type="text" color='white' round size="sm" @click.native="onRemove">
        <template #icon>
          <ClearIcon />
        </template>
      </Button>
    </div>
  </div>
</template>

<script>
import Button from "@/components/base/Button"
import Counter from "@/components/base/Counter";
import ClearIcon from "@/assets/svgs/close.svg";
import numeral from "numeral";
import axios from "axios";

export default {
  name: "CartItem",
  components: {
    Button,
    Counter,
    ClearIcon
  },
  props: {
    product: {
      type: Object,
      required: true
    }
  },
  computed: {
    thumbnail() {
      return `${process.env.baseUrl}/${this.product.thumbnail}`
    },
    price() {
      return (this.product.price * (100 - this.product.off)) / 100;
    }
  },
  filters: {
    formatPrice(price) {
      return numeral(price).format('0,0');
    }
  },
  methods: {
    onIncrease() {
      this.$store.dispatch('cart/push', this.product.id).catch(error => {
        this.$store.dispatch('notifications/push', {
          type: 'warning',
          light: true,
          message: 'در انبار موجود نمی باشد.'
        });
      });
    },
    onDecrease() {
      this.$store.dispatch('cart/pop', this.product.id);
    },
    onRemove() {
      this.$store.dispatch('cart/remove', this.product.id);
    }
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.thumbnail
  width 15rem
  height 15rem
  border-radius .5rem
  background-size cover
  background-position center
  @media only screen and (max-width 800px)
    width 10rem
    height 10rem
  @media only screen and (max-width 600px)
    width 7.5rem
    height 7.5rem
  @media only screen and (max-width 600px)
    width 7.5rem
    height 7.5rem
  @media only screen and (max-width 480px)
    display none

.item
  display flex
  align-items center
  padding $md
  @media only screen and (max-width 600px)
    padding $md $sm
  &:not(:last-of-type)
    border-bottom 1px solid rgba(white, .1)

.info
  margin-right $lg
  @media only screen and (max-width 800px)
    margin-right $md
  @media only screen and (max-width 600px)
    margin-right $sm

.title
  font-weight 400
  @media only screen and (max-width 800px)
    font-size 2rem

.off
  text-decoration line-through
  color $primary

.price-container
  display flex
  align-items center
  @media only screen and (max-width 800px)
    font-size 1.4rem

.price
  margin-left $xxsm

.actions
  margin-right auto
  display flex
  align-items center

.counter
  margin-left $md
  @media only screen and (max-width 600px)
    margin-left $sm
</style>